#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <cmath>
#include <signal.h>
#include <vector>
#include <iostream>
#include <iomanip>
#include <stdexcept>

#include <rs485.h>
#include <astrotime.h>

#include <unistd.h>

#include "dome_device.h"

AstroDateTime utc;

const std::string   sect_device("Devices");
const std::string   subs_adome("Dome");

Device::Device( Config& cf ) : device( cf.inp<std::string>( "General", "Common", "Device") ), rs485( device ) {
    try {                     // exchange starts during RS485 construction
        dome_controller = std::auto_ptr<Astrohaven>( new Astrohaven( cf, rs485, subs_adome ) );
    }
    catch ( const std::exception& e ) {
        ErrlogSingl::instance().wthrow( ERR_STD_EXCP, e.what() );
    }
//    std::cerr << "Constructor Device" << std::endl;
}

Device::~Device() {
//    std::cerr << "Destructor Device" << std::endl;
    try {
    }
    catch( const ErrFat& e ) {
        ErrlogSingl::instance().write( e );
    }
}

