#ifndef _DOME_DEVICE_H
#define _DOME_DEVICE_H

#include <memory>
#include <string>
#include <vector>
#include <pthread.h>

#include "module.h"
#include <configs.h>
#include "deftypes.h"
#include "astrohaven.h"

class Device {
    const std::string device;
    RS485 rs485;
    std::auto_ptr<Astrohaven> dome_controller;
public:
    Device( Config& );
    ~Device();
    double ahaven_time() { return dome_controller->time(); }
    const std::string& domestatus()  { return dome_controller->devStatus(); }
    void ahaven_close_a() { return dome_controller->close_a(); }
    void ahaven_close_b() { return dome_controller->close_b(); }
    void ahaven_open_a() { return dome_controller->open_a(); }
    void ahaven_open_b() { return dome_controller->open_b(); }
    void ahaven_move_a( double p) { return dome_controller->move_a( p ); }
    void ahaven_move_b( double p) { return dome_controller->move_b( p ); }
    bool ahaven_is_closed( bool A, bool B){ return dome_controller->is_closed( A, B); }
    bool ahaven_is_opened( bool A, bool B){ return dome_controller->is_opened( A, B); }
    double ahaven_sideA_position(){ return dome_controller->sideA_position(); }
    double ahaven_sideB_position(){ return dome_controller->sideB_position(); }
};


#endif
