#ifndef _MODES_H
#define _MODES_H

#include <configs.h>
#include "dome_device.h"

class Device;

class Mode {
protected:
    Config *cfg;
    Device *ddv;
    bool   break_mode;
    double up_time;
    static bool sideA;
    static bool sideB;
public:
    Mode( Config&, Device& );
    virtual ~Mode() {} // std::cerr << " Mode" << std::endl; }
    virtual void action() = 0;
    virtual int  life() { return (int)up_time; }
    virtual void stop_request() { break_mode = true; }
    static void segmA(){ sideA = true; sideB = false; }
    static void segmB(){ sideB = true; sideA = false; }
    static void both(){ sideA = true; sideB = true; }
};

class Close : public Mode {
public:
    Close( Config&, Device& );
    virtual ~Close(){} // std::cerr << "Destructor Close :" ;}
    void  action();
    int  life();
};

class Open : public Mode {
public:
    Open( Config&, Device& );
    virtual ~Open(){} //  std::cerr << "Destructor Open :" ; }
    void action();
    int  life();
};

class Move : public Mode {
    double  target;
public:
    Move( Config&, Device& );
    virtual ~Move(){} //  std::cerr << "Destructor Move :" ; }
    void action();
    int  life();
    void set_target( double t ) { target = t; }
};
#endif
