/*
*   socket/event.cpp is a part of programm carbon
*   $Id$
*   Copyright (C) 2006  Matwey V. Kornilov
*
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software
*   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <iostream>

void ServerSocketWithCalls::onStateChanged( const SocketBase::SocketState state ) {
    ServerSocket::onStateChanged( state );
    (server->*(cbtable->onStateChanged))( state );
}

void ServerSocketWithCalls::onAccepted() {
    ServerSocket::onAccepted();
    (server->*(cbtable->onAccepted))();
}

void ServerSocketWithCalls::onError( const DefinedSocketError& e ) {
    ServerSocket::onError( e );
    (server->*(cbtable->onError))( e );
}
    
void ClientSocketWithCalls::onStateChanged( const SocketBase::SocketState state ) {
    ClientSocket::onStateChanged( state );
    (client->*(cbtable->onStateChanged))( state );
}

void ClientSocketWithCalls::onDataRecieved() {
    ClientSocket::onDataRecieved();
    (client->*(cbtable->onDataRecieved))();
}

void ClientSocketWithCalls::onError( const DefinedSocketError& e ) {
    ClientSocket::onError( e );
    (client->*(cbtable->onError))( e ); 
}

ServerSocketWithCalls::ServerSocketWithCalls(CBTableServSock* tbl, Server* serv)
    : cbtable(tbl), server(serv) {
}

ClientSocketWithCalls::ClientSocketWithCalls(ServerSocketWithCalls* servSock, CBTableClientSock* tbl, Client* cl)
    : DefinedClientSocket(servSock), cbtable(tbl), client(cl) {
}

ClientSocketWithCalls::ClientSocketWithCalls( CBTableClientSock* tbl, Client* cl)
    : DefinedClientSocket(), cbtable(tbl), client(cl) {
}
